﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace b1
{
    public partial class FrmMain : Form
    {
        public FrmMain()
        {
            InitializeComponent();
        }

        //注意方法要加上async标识符，标明是异步方法
        private async void btnStart_Click(object sender, EventArgs e)
        {
            txtLog.Text = "准备开始异步操作…  " + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + Environment.NewLine;
            string tmpStr = await ExampleMethodAsync();   //调用异步方法，注意要标明await
            txtLog.AppendText("异步操作完成，返回值是：" + tmpStr + "  " + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + Environment.NewLine);
        }

        async Task<string> ExampleMethodAsync()
        {
            txtLog.AppendText("异步操作进行中…  " + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + Environment.NewLine);
            TaskCompletionSource<string> tcs = new TaskCompletionSource<string>();
            await Task.Delay(5000);  //延迟5秒钟
            tcs.SetResult("Good Job！");  //当调用SetResult方法时，则表示异步执行完成
            return await tcs.Task;   //返回，注意要标明await
        }

        private void btnNew_Click(object sender, EventArgs e)
        {
            txtLog.AppendText("这个是普通方法的执行结果!  " + DateTime.Now.ToString("yyyy-MM-dd HH:mm:ss") + Environment.NewLine);
        }

        private void FrmMain_Load(object sender, EventArgs e)
        {

        }
    }
}
